
#ifndef UDP_SERVER_H
#define UDP_SERVER_H

#include <sys/socket.h>
#include <sys/types.h>
#include <inttypes.h>

#include "select.h"

typedef	int (*udp_receive_cb_t)(const struct sockaddr src_addr, const uint8_t * const buffer, const int length);

typedef struct {
	int fd;

	udp_receive_cb_t receive_cb;

} udp_server_t;

int udp_send(const struct sockaddr * const dst_addr, const int src_port, const uint8_t * const data, const int len);

int udp_server_set_mg(udp_server_t * const inst, const char * const multiaddr, const char * const interface);

int udp_server_open(udp_server_t * const inst, const int port, udp_receive_cb_t receive_cb);

#endif // UDP_SERVER_H

